//*******************************************************************************
//* Copyright (c) 2004-2014 Synchrotron SOLEIL
//* All rights reserved. This program and the accompanying materials
//* are made available under the terms of the GNU Lesser Public License v3
//* which accompanies this distribution, and is available at
//* http://www.gnu.org/licenses/lgpl.html
//******************************************************************************
static const char *ClassId    = "$Id: ImgBeamAnalyzerClass.cpp,v 1.26 2012-07-09 14:05:48 sergiblanch Exp $";
static const char *CvsPath    = "$Source: /users/chaize/newsvn/cvsroot/Calculation/ImgBeamAnalyzer/src/ImgBeamAnalyzerClass.cpp,v $";
static const char *SvnPath    = "$HeadURL: $";
static const char *RcsId     = "$Header: /users/chaize/newsvn/cvsroot/Calculation/ImgBeamAnalyzer/src/ImgBeamAnalyzerClass.cpp,v 1.26 2012-07-09 14:05:48 sergiblanch Exp $";
static const char *TagName   = "$Name: not supported by cvs2svn $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        ImgBeamAnalyzerClass.cpp
//
// description : C++ source for the ImgBeamAnalyzerClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the ImgBeamAnalyzer once per process.
//
// project :     TANGO Device Server
//
// $Author: sergiblanch $
//
// $Revision: 1.26 $
//
// $Log: not supported by cvs2svn $
// Revision 1.25  2011/12/09 15:35:20  jcpret
// Fixed Mantis buf 14571
//
// Revision 1.24  2010/04/12 08:31:45  flanglois
// switch to impl4
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <ImgBeamAnalyzer.h>
#include <ImgBeamAnalyzerClass.h>


namespace ImgBeamAnalyzer_ns
{

//+----------------------------------------------------------------------------
//
// method : 		GetVersionNumberClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetVersionNumberClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetVersionNumberClass::execute(): arrived" << endl;

	return insert((static_cast<ImgBeamAnalyzer *>(device))->get_version_number());
}


//+----------------------------------------------------------------------------
//
// method : 		ProcessCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ProcessCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ProcessCmd::execute(): arrived" << endl;

	((static_cast<ImgBeamAnalyzer *>(device))->process());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SaveCurrentSettingsCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SaveCurrentSettingsCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SaveCurrentSettingsCmd::execute(): arrived" << endl;

	((static_cast<ImgBeamAnalyzer *>(device))->save_current_settings());
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		StopCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StopCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StopCmd::execute(): arrived" << endl;

	((static_cast<ImgBeamAnalyzer *>(device))->stop());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		StartCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StartCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StartCmd::execute(): arrived" << endl;

	((static_cast<ImgBeamAnalyzer *>(device))->start());
	return new CORBA::Any();
}


//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
ImgBeamAnalyzerClass *ImgBeamAnalyzerClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::ImgBeamAnalyzerClass(string &s)
// 
// description : 	constructor for the ImgBeamAnalyzerClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
ImgBeamAnalyzerClass::ImgBeamAnalyzerClass(string &s):DeviceClass(s)
{

	cout2 << "Entering ImgBeamAnalyzerClass constructor" << endl;
	get_class_property();
	set_default_property();
	write_class_property();
	
	cout2 << "Leaving ImgBeamAnalyzerClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::~ImgBeamAnalyzerClass()
// 
// description : 	destructor for the ImgBeamAnalyzerClass
//
//-----------------------------------------------------------------------------
ImgBeamAnalyzerClass::~ImgBeamAnalyzerClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
ImgBeamAnalyzerClass *ImgBeamAnalyzerClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new ImgBeamAnalyzerClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

ImgBeamAnalyzerClass *ImgBeamAnalyzerClass::instance()
{
	if (_instance == NULL)
	{
//		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void ImgBeamAnalyzerClass::command_factory()
{
	command_list.push_back(new StartCmd("Start",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new StopCmd("Stop",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ProcessCmd("Process",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SaveCurrentSettingsCmd("SaveCurrentSettings",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetVersionNumberClass("GetVersionNumber",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"the Device Server version number",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum ImgBeamAnalyzerClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum ImgBeamAnalyzerClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum ImgBeamAnalyzerClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void ImgBeamAnalyzerClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new ImgBeamAnalyzer(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: ImgBeamAnalyzerClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void ImgBeamAnalyzerClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : EnableImageStats
	EnableImageStatsAttrib	*enable_image_stats = new EnableImageStatsAttrib();
	Tango::UserDefaultAttrProp	enable_image_stats_prop;
	enable_image_stats_prop.set_label("EnableImageStats");
	enable_image_stats_prop.set_description("enables the computation of image moments (centroid, variance, skew) and maximal intensity");
	enable_image_stats->set_default_properties(enable_image_stats_prop);
	att_list.push_back(enable_image_stats);

	//	Attribute : EnableProfiles
	EnableProfilesAttrib	*enable_profiles = new EnableProfilesAttrib();
	Tango::UserDefaultAttrProp	enable_profiles_prop;
	enable_profiles_prop.set_label("EnableProfiles");
	enable_profiles_prop.set_description("enables the computation of the X and Y profiles, and the corresponding gaussian fit");
	enable_profiles->set_default_properties(enable_profiles_prop);
	att_list.push_back(enable_profiles);

	//	Attribute : EnableHistogram
	EnableHistogramAttrib	*enable_histogram = new EnableHistogramAttrib();
	Tango::UserDefaultAttrProp	enable_histogram_prop;
	enable_histogram_prop.set_label("Enable Histogram");
	enable_histogram_prop.set_description("enables the computation of the histogram of the image");
	enable_histogram->set_default_properties(enable_histogram_prop);
	att_list.push_back(enable_histogram);

	//	Attribute : EnableUserROI
	EnableUserROIAttrib	*enable_user_roi = new EnableUserROIAttrib();
	Tango::UserDefaultAttrProp	enable_user_roi_prop;
	enable_user_roi_prop.set_label("EnableUserROI");
	enable_user_roi_prop.set_description("enables the use of the UserROIOriginX, UserROIOriginY, UserROIWidth, UserROIHeight to define the ROI that will be processed");
	enable_user_roi->set_default_properties(enable_user_roi_prop);
	att_list.push_back(enable_user_roi);

	//	Attribute : EnableAutoROI
	EnableAutoROIAttrib	*enable_auto_roi = new EnableAutoROIAttrib();
	Tango::UserDefaultAttrProp	enable_auto_roi_prop;
	enable_auto_roi_prop.set_label("EnableAutoROI");
	enable_auto_roi_prop.set_description("if true, the ROI is detected automatically to encompass the biggest particle in the image");
	enable_auto_roi->set_default_properties(enable_auto_roi_prop);
	att_list.push_back(enable_auto_roi);

	//	Attribute : Enable2DGaussianFit
	Enable2DGaussianFitAttrib	*enable2_dgaussian_fit = new Enable2DGaussianFitAttrib();
	Tango::UserDefaultAttrProp	enable2_dgaussian_fit_prop;
	enable2_dgaussian_fit_prop.set_label("Enable2DGaussianFit");
	enable2_dgaussian_fit_prop.set_description("enables the 2D gaussian fitting");
	enable2_dgaussian_fit->set_default_properties(enable2_dgaussian_fit_prop);
	att_list.push_back(enable2_dgaussian_fit);

	//	Attribute : ComputationPeriod
	ComputationPeriodAttrib	*computation_period = new ComputationPeriodAttrib();
	Tango::UserDefaultAttrProp	computation_period_prop;
	computation_period_prop.set_label("ComputationPeriod");
	computation_period_prop.set_unit("ms");
	computation_period_prop.set_format("%5d");
	computation_period_prop.set_description("period in millisecond at which a new image is read and processed");
	computation_period->set_default_properties(computation_period_prop);
	att_list.push_back(computation_period);

	//	Attribute : EstimComputTime
	EstimComputTimeAttrib	*estim_comput_time = new EstimComputTimeAttrib();
	Tango::UserDefaultAttrProp	estim_comput_time_prop;
	estim_comput_time_prop.set_label("EstimComputTime");
	estim_comput_time_prop.set_unit("ms");
	estim_comput_time_prop.set_format("%5d");
	estim_comput_time_prop.set_description("time spent, in ms, to process the image");
	estim_comput_time->set_default_properties(estim_comput_time_prop);
	att_list.push_back(estim_comput_time);

	//	Attribute : Rotation
	RotationAttrib	*rotation = new RotationAttrib();
	Tango::UserDefaultAttrProp	rotation_prop;
	rotation_prop.set_label("Rotation");
	rotation_prop.set_unit("deg");
	rotation_prop.set_format("%4d");
	rotation_prop.set_description("the rotation applied in preprocessing. only multiple of 90 are recognized as valid values");
	rotation->set_default_properties(rotation_prop);
	att_list.push_back(rotation);

	//	Attribute : HorizontalFlip
	HorizontalFlipAttrib	*horizontal_flip = new HorizontalFlipAttrib();
	Tango::UserDefaultAttrProp	horizontal_flip_prop;
	horizontal_flip_prop.set_label("HorizontalFlip");
	horizontal_flip_prop.set_description("if true, the image is flipped horizontally in preprocessing, after having been rotated");
	horizontal_flip->set_default_properties(horizontal_flip_prop);
	att_list.push_back(horizontal_flip);

	//	Attribute : BitsPerPixel
	BitsPerPixelAttrib	*bits_per_pixel = new BitsPerPixelAttrib();
	Tango::UserDefaultAttrProp	bits_per_pixel_prop;
	bits_per_pixel_prop.set_label("BitsPerPixel");
	bits_per_pixel_prop.set_unit(" ");
	bits_per_pixel_prop.set_format("%2d");
	bits_per_pixel_prop.set_description("the pixel depth for significative information in the image (usually 8 or 10).\nit is used only in the gamma correction to keep a constant dynamic range of pixel values when raising these values to a power");
	bits_per_pixel->set_default_properties(bits_per_pixel_prop);
	att_list.push_back(bits_per_pixel);

	//	Attribute : HistogramNbBins
	HistogramNbBinsAttrib	*histogram_nb_bins = new HistogramNbBinsAttrib();
	Tango::UserDefaultAttrProp	histogram_nb_bins_prop;
	histogram_nb_bins_prop.set_label("HistogramNbBins");
	histogram_nb_bins_prop.set_unit(" ");
	histogram_nb_bins_prop.set_format("%4d");
	histogram_nb_bins_prop.set_description("the number of bins in the histogram. if set to 0, the maximum possible number of bins is used");
	histogram_nb_bins->set_default_properties(histogram_nb_bins_prop);
	att_list.push_back(histogram_nb_bins);

	//	Attribute : HistogramRangeMin
	HistogramRangeMinAttrib	*histogram_range_min = new HistogramRangeMinAttrib();
	Tango::UserDefaultAttrProp	histogram_range_min_prop;
	histogram_range_min_prop.set_label("HistogramRange Min");
	histogram_range_min_prop.set_unit(" ");
	histogram_range_min_prop.set_format("%4d");
	histogram_range_min_prop.set_description("the lower bound of the histogram bins. must be >= 0");
	histogram_range_min->set_default_properties(histogram_range_min_prop);
	att_list.push_back(histogram_range_min);

	//	Attribute : HistogramRangeMax
	HistogramRangeMaxAttrib	*histogram_range_max = new HistogramRangeMaxAttrib();
	Tango::UserDefaultAttrProp	histogram_range_max_prop;
	histogram_range_max_prop.set_label("HistogramRange Max");
	histogram_range_max_prop.set_unit(" ");
	histogram_range_max_prop.set_format("%4d");
	histogram_range_max_prop.set_description("the upper bound of the histogram bins. must be <= 2^BitsPerPixel - 1\nif set to 0, the maximal possible value is taken (2^BitsPerPixel - 1)");
	histogram_range_max->set_default_properties(histogram_range_max_prop);
	att_list.push_back(histogram_range_max);

	//	Attribute : GammaCorrection
	GammaCorrectionAttrib	*gamma_correction = new GammaCorrectionAttrib();
	Tango::UserDefaultAttrProp	gamma_correction_prop;
	gamma_correction_prop.set_label("GammaCorrection");
	gamma_correction_prop.set_unit(" ");
	gamma_correction_prop.set_format("%4.2f");
	gamma_correction_prop.set_description("the gamma value of the camera, used to correct the ROI image by raising to its inverse power");
	gamma_correction->set_default_properties(gamma_correction_prop);
	att_list.push_back(gamma_correction);

	//	Attribute : AutoROIMagFactorX
	AutoROIMagFactorXAttrib	*auto_roimag_factor_x = new AutoROIMagFactorXAttrib();
	Tango::UserDefaultAttrProp	auto_roimag_factor_x_prop;
	auto_roimag_factor_x_prop.set_label("AutoROI Magnification Factor X");
	auto_roimag_factor_x_prop.set_unit(" ");
	auto_roimag_factor_x_prop.set_format("%4.2f");
	auto_roimag_factor_x_prop.set_description("the scaling factor in the X direction applied to the AutoROI");
	auto_roimag_factor_x->set_default_properties(auto_roimag_factor_x_prop);
	att_list.push_back(auto_roimag_factor_x);

	//	Attribute : AutoROIMagFactorY
	AutoROIMagFactorYAttrib	*auto_roimag_factor_y = new AutoROIMagFactorYAttrib();
	Tango::UserDefaultAttrProp	auto_roimag_factor_y_prop;
	auto_roimag_factor_y_prop.set_label("AutoROI Magnification Factor Y");
	auto_roimag_factor_y_prop.set_unit(" ");
	auto_roimag_factor_y_prop.set_format("%4.2f");
	auto_roimag_factor_y_prop.set_description("the scaling factor in the Y direction applied to the AutoROI");
	auto_roimag_factor_y->set_default_properties(auto_roimag_factor_y_prop);
	att_list.push_back(auto_roimag_factor_y);

	//	Attribute : AutoROIThreshold
	AutoROIThresholdAttrib	*auto_roithreshold = new AutoROIThresholdAttrib();
	Tango::UserDefaultAttrProp	auto_roithreshold_prop;
	auto_roithreshold_prop.set_label("AutoROIThreshold");
	auto_roithreshold_prop.set_unit(" ");
	auto_roithreshold_prop.set_format("%4d");
	auto_roithreshold_prop.set_description("the threshold, used only if AutoROIMethod is set to THRESHOLD");
	auto_roithreshold->set_default_properties(auto_roithreshold_prop);
	att_list.push_back(auto_roithreshold);

	//	Attribute : BgSubstraction
	BgSubstractionAttrib	*bg_substraction = new BgSubstractionAttrib();
	Tango::UserDefaultAttrProp	bg_substraction_prop;
	bg_substraction_prop.set_label("Background Substraction");
	bg_substraction_prop.set_unit(" ");
	bg_substraction_prop.set_format("%5.2f");
	bg_substraction_prop.set_description("the scalar value to substract to each pixel");
	bg_substraction->set_default_properties(bg_substraction_prop);
	att_list.push_back(bg_substraction);

	//	Attribute : AlarmZone
	AlarmZoneAttrib	*alarm_zone = new AlarmZoneAttrib();
	Tango::UserDefaultAttrProp	alarm_zone_prop;
	alarm_zone_prop.set_label("AlarmZone");
	alarm_zone_prop.set_unit("pix");
	alarm_zone_prop.set_format("%3d");
	alarm_zone_prop.set_min_value("0");
	alarm_zone_prop.set_description("if EnableAutoROI is set to true and if the distance between a beam box corner and the border of the image falls below this threshold, attributes quality are set to ALARM");
	alarm_zone->set_default_properties(alarm_zone_prop);
	att_list.push_back(alarm_zone);

	//	Attribute : PixelSizeX
	PixelSizeXAttrib	*pixel_size_x = new PixelSizeXAttrib();
	Tango::UserDefaultAttrProp	pixel_size_x_prop;
	pixel_size_x_prop.set_label("PixelSizeX");
	pixel_size_x_prop.set_unit("um/pix");
	pixel_size_x_prop.set_format("%5.2f");
	pixel_size_x_prop.set_description("the horizontal size of the pixels of the CCD in um per pixel");
	pixel_size_x->set_default_properties(pixel_size_x_prop);
	att_list.push_back(pixel_size_x);

	//	Attribute : PixelSizeY
	PixelSizeYAttrib	*pixel_size_y = new PixelSizeYAttrib();
	Tango::UserDefaultAttrProp	pixel_size_y_prop;
	pixel_size_y_prop.set_label("PixelSizeY");
	pixel_size_y_prop.set_unit("um/pix");
	pixel_size_y_prop.set_format("%5.2f");
	pixel_size_y_prop.set_description("the vertical size of the pixels of the CCD in um per pixel");
	pixel_size_y->set_default_properties(pixel_size_y_prop);
	att_list.push_back(pixel_size_y);

	//	Attribute : OpticalMagnification
	OpticalMagnificationAttrib	*optical_magnification = new OpticalMagnificationAttrib();
	Tango::UserDefaultAttrProp	optical_magnification_prop;
	optical_magnification_prop.set_label("OpticalMagnification");
	optical_magnification_prop.set_unit(" ");
	optical_magnification_prop.set_format("%5.2f");
	optical_magnification_prop.set_description("the magnification factor of the optical system (no unit)");
	optical_magnification->set_default_properties(optical_magnification_prop);
	att_list.push_back(optical_magnification);

	//	Attribute : ProfileFitFixedBg
	ProfileFitFixedBgAttrib	*profile_fit_fixed_bg = new ProfileFitFixedBgAttrib();
	Tango::UserDefaultAttrProp	profile_fit_fixed_bg_prop;
	profile_fit_fixed_bg_prop.set_label("Profiles Fit with Fixed Background");
	profile_fit_fixed_bg_prop.set_description("if true, the background noise is estimated from the border of the whole image and this background value stays fixed during the fit");
	profile_fit_fixed_bg->set_default_properties(profile_fit_fixed_bg_prop);
	att_list.push_back(profile_fit_fixed_bg);

	//	Attribute : LineProfileOriginX
	LineProfileOriginXAttrib	*line_profile_origin_x = new LineProfileOriginXAttrib();
	Tango::UserDefaultAttrProp	line_profile_origin_x_prop;
	line_profile_origin_x_prop.set_label("LineProfile Origin X");
	line_profile_origin_x_prop.set_unit("pix");
	line_profile_origin_x_prop.set_format("%4d");
	line_profile_origin_x_prop.set_description("the X coordinate of the origin point of the line profile");
	line_profile_origin_x->set_default_properties(line_profile_origin_x_prop);
	att_list.push_back(line_profile_origin_x);

	//	Attribute : LineProfileOriginY
	LineProfileOriginYAttrib	*line_profile_origin_y = new LineProfileOriginYAttrib();
	Tango::UserDefaultAttrProp	line_profile_origin_y_prop;
	line_profile_origin_y_prop.set_label("LineProfile Origin Y");
	line_profile_origin_y_prop.set_unit("pix");
	line_profile_origin_y_prop.set_format("%4d");
	line_profile_origin_y_prop.set_description("the Y coordinate of the origin point of the line profile");
	line_profile_origin_y->set_default_properties(line_profile_origin_y_prop);
	att_list.push_back(line_profile_origin_y);

	//	Attribute : LineProfileEndX
	LineProfileEndXAttrib	*line_profile_end_x = new LineProfileEndXAttrib();
	Tango::UserDefaultAttrProp	line_profile_end_x_prop;
	line_profile_end_x_prop.set_label("LineProfile End X");
	line_profile_end_x_prop.set_unit("pix");
	line_profile_end_x_prop.set_format("%4d");
	line_profile_end_x_prop.set_description("the X coordinate of the endpoint of the line profile");
	line_profile_end_x->set_default_properties(line_profile_end_x_prop);
	att_list.push_back(line_profile_end_x);

	//	Attribute : LineProfileEndY
	LineProfileEndYAttrib	*line_profile_end_y = new LineProfileEndYAttrib();
	Tango::UserDefaultAttrProp	line_profile_end_y_prop;
	line_profile_end_y_prop.set_label("LineProfile End Y");
	line_profile_end_y_prop.set_unit("pix");
	line_profile_end_y_prop.set_format("%4d");
	line_profile_end_y_prop.set_description("the Y coordinate of the endpoint of the line profile");
	line_profile_end_y->set_default_properties(line_profile_end_y_prop);
	att_list.push_back(line_profile_end_y);

	//	Attribute : LineProfileThickness
	LineProfileThicknessAttrib	*line_profile_thickness = new LineProfileThicknessAttrib();
	Tango::UserDefaultAttrProp	line_profile_thickness_prop;
	line_profile_thickness_prop.set_label("LineProfile Thickness");
	line_profile_thickness_prop.set_unit("pix");
	line_profile_thickness_prop.set_format("%4d");
	line_profile_thickness_prop.set_min_value("1");
	line_profile_thickness_prop.set_description("defines the number of lines used to average a local line profile");
	line_profile_thickness->set_default_properties(line_profile_thickness_prop);
	att_list.push_back(line_profile_thickness);

	//	Attribute : ChamberOffsetX
	ChamberOffsetXAttrib	*chamber_offset_x = new ChamberOffsetXAttrib();
	Tango::UserDefaultAttrProp	chamber_offset_x_prop;
	chamber_offset_x_prop.set_label("Chamber Center Offset X");
	chamber_offset_x_prop.set_unit("um");
	chamber_offset_x_prop.set_format("%6.2f");
	chamber_offset_x_prop.set_description("An offset to be substracted to CentroidX and XProjFitCenter and get Chamber*");
	chamber_offset_x->set_default_properties(chamber_offset_x_prop);
	att_list.push_back(chamber_offset_x);

	//	Attribute : ChamberOffsetY
	ChamberOffsetYAttrib	*chamber_offset_y = new ChamberOffsetYAttrib();
	Tango::UserDefaultAttrProp	chamber_offset_y_prop;
	chamber_offset_y_prop.set_label("Chamber Center Offset Y");
	chamber_offset_y_prop.set_unit("um");
	chamber_offset_y_prop.set_format("%6.2f");
	chamber_offset_y_prop.set_description("An offset to be substracted to CentroidY and YProjFitCenter and get Chamber*");
	chamber_offset_y->set_default_properties(chamber_offset_y_prop);
	att_list.push_back(chamber_offset_y);

	//	Attribute : ChamberCentroidX
	ChamberCentroidXAttrib	*chamber_centroid_x = new ChamberCentroidXAttrib();
	Tango::UserDefaultAttrProp	chamber_centroid_x_prop;
	chamber_centroid_x_prop.set_label("Ch Centroid X");
	chamber_centroid_x_prop.set_unit("um");
	chamber_centroid_x_prop.set_format("%10.2f");
	chamber_centroid_x_prop.set_description("the X coordinate of the centroid, relative to Chamber.");
	chamber_centroid_x->set_default_properties(chamber_centroid_x_prop);
	att_list.push_back(chamber_centroid_x);

	//	Attribute : ChamberCentroidY
	ChamberCentroidYAttrib	*chamber_centroid_y = new ChamberCentroidYAttrib();
	Tango::UserDefaultAttrProp	chamber_centroid_y_prop;
	chamber_centroid_y_prop.set_label("Ch Centroid Y");
	chamber_centroid_y_prop.set_unit("um");
	chamber_centroid_y_prop.set_format("%10.2f");
	chamber_centroid_y_prop.set_description("the Y coordinate of the centroid, relative to Chamber.");
	chamber_centroid_y->set_default_properties(chamber_centroid_y_prop);
	att_list.push_back(chamber_centroid_y);

	//	Attribute : ChamberXProjFitCenter
	ChamberXProjFitCenterAttrib	*chamber_xproj_fit_center = new ChamberXProjFitCenterAttrib();
	Tango::UserDefaultAttrProp	chamber_xproj_fit_center_prop;
	chamber_xproj_fit_center_prop.set_label("X Proj Fit Center");
	chamber_xproj_fit_center_prop.set_unit("um");
	chamber_xproj_fit_center_prop.set_format("%10.2f");
	chamber_xproj_fit_center_prop.set_description("the X position of the center of the fitted gaussian corresponding to the X projection relative to Chamber");
	chamber_xproj_fit_center->set_default_properties(chamber_xproj_fit_center_prop);
	att_list.push_back(chamber_xproj_fit_center);

	//	Attribute : ChamberYProjFitCenter
	ChamberYProjFitCenterAttrib	*chamber_yproj_fit_center = new ChamberYProjFitCenterAttrib();
	Tango::UserDefaultAttrProp	chamber_yproj_fit_center_prop;
	chamber_yproj_fit_center_prop.set_label("X Proj Fit Center");
	chamber_yproj_fit_center_prop.set_unit("um");
	chamber_yproj_fit_center_prop.set_format("%10.2f");
	chamber_yproj_fit_center_prop.set_description("the X position of the center of the fitted gaussian corresponding to the X projection relative to Chamber");
	chamber_yproj_fit_center->set_default_properties(chamber_yproj_fit_center_prop);
	att_list.push_back(chamber_yproj_fit_center);

	//	Attribute : UserROIOriginX
	UserROIOriginXAttrib	*user_roiorigin_x = new UserROIOriginXAttrib();
	Tango::UserDefaultAttrProp	user_roiorigin_x_prop;
	user_roiorigin_x_prop.set_label("User ROI Origin X");
	user_roiorigin_x_prop.set_unit("pix");
	user_roiorigin_x_prop.set_format("%4d");
	user_roiorigin_x_prop.set_min_value("0");
	user_roiorigin_x_prop.set_description("the X coordinate of the origin of the ROI (up-left corner) in pixels");
	user_roiorigin_x->set_default_properties(user_roiorigin_x_prop);
	att_list.push_back(user_roiorigin_x);

	//	Attribute : UserROIOriginY
	UserROIOriginYAttrib	*user_roiorigin_y = new UserROIOriginYAttrib();
	Tango::UserDefaultAttrProp	user_roiorigin_y_prop;
	user_roiorigin_y_prop.set_label("User ROI Origin Y");
	user_roiorigin_y_prop.set_unit("pix");
	user_roiorigin_y_prop.set_format("%4d");
	user_roiorigin_y_prop.set_min_value("0");
	user_roiorigin_y_prop.set_description("the Y coordinate of the origin of the ROI (up-left corner)");
	user_roiorigin_y->set_default_properties(user_roiorigin_y_prop);
	att_list.push_back(user_roiorigin_y);

	//	Attribute : UserROIWidth
	UserROIWidthAttrib	*user_roiwidth = new UserROIWidthAttrib();
	Tango::UserDefaultAttrProp	user_roiwidth_prop;
	user_roiwidth_prop.set_label("User ROI Width");
	user_roiwidth_prop.set_unit("pix");
	user_roiwidth_prop.set_format("%4d");
	user_roiwidth_prop.set_min_value("0");
	user_roiwidth_prop.set_description("the width of the ROI in pixels");
	user_roiwidth->set_default_properties(user_roiwidth_prop);
	att_list.push_back(user_roiwidth);

	//	Attribute : UserROIHeight
	UserROIHeightAttrib	*user_roiheight = new UserROIHeightAttrib();
	Tango::UserDefaultAttrProp	user_roiheight_prop;
	user_roiheight_prop.set_label("User ROI Height");
	user_roiheight_prop.set_unit("pix");
	user_roiheight_prop.set_format("%4d");
	user_roiheight_prop.set_min_value("0");
	user_roiheight_prop.set_description("the height of the ROI in pixels");
	user_roiheight->set_default_properties(user_roiheight_prop);
	att_list.push_back(user_roiheight);

	//	Attribute : AutoROIFound
	AutoROIFoundAttrib	*auto_roifound = new AutoROIFoundAttrib();
	Tango::UserDefaultAttrProp	auto_roifound_prop;
	auto_roifound_prop.set_label("AutoROI Found");
	auto_roifound_prop.set_description("true if the AutoROI algorithm was used and did found a beam inside the image");
	auto_roifound->set_default_properties(auto_roifound_prop);
	att_list.push_back(auto_roifound);

	//	Attribute : AutoROIOriginX
	AutoROIOriginXAttrib	*auto_roiorigin_x = new AutoROIOriginXAttrib();
	Tango::UserDefaultAttrProp	auto_roiorigin_x_prop;
	auto_roiorigin_x_prop.set_label("Auto ROI Origin X");
	auto_roiorigin_x_prop.set_unit("pix");
	auto_roiorigin_x_prop.set_format("%4d");
	auto_roiorigin_x_prop.set_description("the X coordinate of the origin of the ROI (up-left corner) in pixels");
	auto_roiorigin_x->set_default_properties(auto_roiorigin_x_prop);
	att_list.push_back(auto_roiorigin_x);

	//	Attribute : AutoROIOriginY
	AutoROIOriginYAttrib	*auto_roiorigin_y = new AutoROIOriginYAttrib();
	Tango::UserDefaultAttrProp	auto_roiorigin_y_prop;
	auto_roiorigin_y_prop.set_label("Auto ROI Origin Y");
	auto_roiorigin_y_prop.set_unit("pix");
	auto_roiorigin_y_prop.set_format("%4d");
	auto_roiorigin_y_prop.set_description("the Y coordinate of the origin of the ROI (up-left corner) in pixels");
	auto_roiorigin_y->set_default_properties(auto_roiorigin_y_prop);
	att_list.push_back(auto_roiorigin_y);

	//	Attribute : AutoROIWidth
	AutoROIWidthAttrib	*auto_roiwidth = new AutoROIWidthAttrib();
	Tango::UserDefaultAttrProp	auto_roiwidth_prop;
	auto_roiwidth_prop.set_label("Auto ROI Width");
	auto_roiwidth_prop.set_unit("pix");
	auto_roiwidth_prop.set_format("%4d");
	auto_roiwidth_prop.set_description("the width of the automatically detected ROI");
	auto_roiwidth->set_default_properties(auto_roiwidth_prop);
	att_list.push_back(auto_roiwidth);

	//	Attribute : AutoROIHeight
	AutoROIHeightAttrib	*auto_roiheight = new AutoROIHeightAttrib();
	Tango::UserDefaultAttrProp	auto_roiheight_prop;
	auto_roiheight_prop.set_label("Auto ROI Height");
	auto_roiheight_prop.set_unit("pix");
	auto_roiheight_prop.set_format("%4d");
	auto_roiheight_prop.set_description("the height of the automatically detected ROI");
	auto_roiheight->set_default_properties(auto_roiheight_prop);
	att_list.push_back(auto_roiheight);

	//	Attribute : TotalIntensity
	TotalIntensityAttrib	*total_intensity = new TotalIntensityAttrib();
	Tango::UserDefaultAttrProp	total_intensity_prop;
	total_intensity_prop.set_label("TotalIntensity");
	total_intensity_prop.set_unit(" ");
	total_intensity_prop.set_format("%10.2f");
	total_intensity_prop.set_description("the total intensity inside the ROI");
	total_intensity->set_default_properties(total_intensity_prop);
	att_list.push_back(total_intensity);

	//	Attribute : MaxIntensity
	MaxIntensityAttrib	*max_intensity = new MaxIntensityAttrib();
	Tango::UserDefaultAttrProp	max_intensity_prop;
	max_intensity_prop.set_label("MaxIntensity");
	max_intensity_prop.set_unit(" ");
	max_intensity_prop.set_format("%10d");
	max_intensity_prop.set_description("the maximal intensity inside the ROI");
	max_intensity->set_default_properties(max_intensity_prop);
	att_list.push_back(max_intensity);

	//	Attribute : MeanIntensity
	MeanIntensityAttrib	*mean_intensity = new MeanIntensityAttrib();
	Tango::UserDefaultAttrProp	mean_intensity_prop;
	mean_intensity_prop.set_label("MeanIntensity");
	mean_intensity_prop.set_unit(" ");
	mean_intensity_prop.set_format("%10.2f");
	mean_intensity_prop.set_description("the mean intensity inside the ROI");
	mean_intensity->set_default_properties(mean_intensity_prop);
	att_list.push_back(mean_intensity);

	//	Attribute : CentroidX
	CentroidXAttrib	*centroid_x = new CentroidXAttrib();
	Tango::UserDefaultAttrProp	centroid_x_prop;
	centroid_x_prop.set_label("CentroidX");
	centroid_x_prop.set_unit("um");
	centroid_x_prop.set_format("%10.2f");
	centroid_x_prop.set_description("the X coordinate of the centroid");
	centroid_x->set_default_properties(centroid_x_prop);
	att_list.push_back(centroid_x);

	//	Attribute : CentroidY
	CentroidYAttrib	*centroid_y = new CentroidYAttrib();
	Tango::UserDefaultAttrProp	centroid_y_prop;
	centroid_y_prop.set_label("CentroidY");
	centroid_y_prop.set_unit("um");
	centroid_y_prop.set_format("%10.2f");
	centroid_y_prop.set_description("the Y coordinate of the centroid");
	centroid_y->set_default_properties(centroid_y_prop);
	att_list.push_back(centroid_y);

	//	Attribute : CentroidSaturated
	CentroidSaturatedAttrib	*centroid_saturated = new CentroidSaturatedAttrib();
	Tango::UserDefaultAttrProp	centroid_saturated_prop;
	centroid_saturated_prop.set_label("CentroidSaturated");
	centroid_saturated_prop.set_description("Is the pixel area around the centroid saturated?");
	centroid_saturated->set_default_properties(centroid_saturated_prop);
	att_list.push_back(centroid_saturated);

	//	Attribute : CentroidSaturationRegionSide
	CentroidSaturationRegionSideAttrib *centroid_side = new CentroidSaturationRegionSideAttrib();
	Tango::UserDefaultAttrProp	centroid_side_prop;
	centroid_side_prop.set_label("CentroidSaturationRegionSide");
	centroid_side_prop.set_description("See CentroidSaturated.");
	centroid_side->set_default_properties(centroid_side_prop);
	att_list.push_back(centroid_side);

	//	Attribute : CentroidSaturationRegionThreshold
	CentroidSaturationRegionThresholdAttrib *centroid_threshold = new CentroidSaturationRegionThresholdAttrib();
	Tango::UserDefaultAttrProp	centroid_threshold_prop;
	centroid_threshold_prop.set_label("CentroidSaturationRegionThreshold");
	centroid_threshold_prop.set_description("See CentroidSaturated.");
	centroid_threshold->set_default_properties(centroid_threshold_prop);
	att_list.push_back(centroid_threshold);

	//	Attribute : VarianceX
	VarianceXAttrib	*variance_x = new VarianceXAttrib();
	Tango::UserDefaultAttrProp	variance_x_prop;
	variance_x_prop.set_label("VarianceX");
	variance_x_prop.set_unit("um^2");
	variance_x_prop.set_format("%10.2f");
	variance_x_prop.set_description("the variance along the X axis");
	variance_x->set_default_properties(variance_x_prop);
	att_list.push_back(variance_x);

	//	Attribute : VarianceY
	VarianceYAttrib	*variance_y = new VarianceYAttrib();
	Tango::UserDefaultAttrProp	variance_y_prop;
	variance_y_prop.set_label("VarianceY");
	variance_y_prop.set_unit("um^2");
	variance_y_prop.set_format("%10.2f");
	variance_y_prop.set_description("the variance along the Y axis");
	variance_y->set_default_properties(variance_y_prop);
	att_list.push_back(variance_y);

	//	Attribute : CovarianceXY
	CovarianceXYAttrib	*covariance_xy = new CovarianceXYAttrib();
	Tango::UserDefaultAttrProp	covariance_xy_prop;
	covariance_xy_prop.set_label("Covariance X-Y");
	covariance_xy_prop.set_unit("um^2");
	covariance_xy_prop.set_format("%10.2f");
	covariance_xy_prop.set_description("the covariance with respect to the X and Y axis");
	covariance_xy->set_default_properties(covariance_xy_prop);
	att_list.push_back(covariance_xy);

	//	Attribute : CorrelationXY
	CorrelationXYAttrib	*correlation_xy = new CorrelationXYAttrib();
	Tango::UserDefaultAttrProp	correlation_xy_prop;
	correlation_xy_prop.set_label("Correlation Coefficient");
	correlation_xy_prop.set_unit(" ");
	correlation_xy_prop.set_format("%10.4f");
	correlation_xy_prop.set_description("the correlation coefficient between the X and Y axises");
	correlation_xy->set_default_properties(correlation_xy_prop);
	att_list.push_back(correlation_xy);

	//	Attribute : SkewX
	SkewXAttrib	*skew_x = new SkewXAttrib();
	Tango::UserDefaultAttrProp	skew_x_prop;
	skew_x_prop.set_label("Skew X^3");
	skew_x_prop.set_unit("um^3");
	skew_x_prop.set_format("%10.2f");
	skew_x_prop.set_description("the skew along the X axis");
	skew_x->set_default_properties(skew_x_prop);
	att_list.push_back(skew_x);

	//	Attribute : SkewY
	SkewYAttrib	*skew_y = new SkewYAttrib();
	Tango::UserDefaultAttrProp	skew_y_prop;
	skew_y_prop.set_label("Skew Y^3");
	skew_y_prop.set_unit("um^3");
	skew_y_prop.set_format("%10.2f");
	skew_y_prop.set_description("the skew along the Y axis");
	skew_y->set_default_properties(skew_y_prop);
	att_list.push_back(skew_y);

	//	Attribute : SkewX2Y
	SkewX2YAttrib	*skew_x2_y = new SkewX2YAttrib();
	Tango::UserDefaultAttrProp	skew_x2_y_prop;
	skew_x2_y_prop.set_label("Skew X^2.Y");
	skew_x2_y_prop.set_unit("um^3");
	skew_x2_y_prop.set_format("%10.2f");
	skew_x2_y_prop.set_description("the skew cross coefficient for X^2.Y");
	skew_x2_y->set_default_properties(skew_x2_y_prop);
	att_list.push_back(skew_x2_y);

	//	Attribute : SkewXY2
	SkewXY2Attrib	*skew_xy2 = new SkewXY2Attrib();
	Tango::UserDefaultAttrProp	skew_xy2_prop;
	skew_xy2_prop.set_label("Skew X.Y^2");
	skew_xy2_prop.set_unit("um^3");
	skew_xy2_prop.set_format("%10.2f");
	skew_xy2_prop.set_description("the skew cross coefficient for X.Y^2");
	skew_xy2->set_default_properties(skew_xy2_prop);
	att_list.push_back(skew_xy2);

	//	Attribute : XProjFitConverged
	XProjFitConvergedAttrib	*xproj_fit_converged = new XProjFitConvergedAttrib();
	Tango::UserDefaultAttrProp	xproj_fit_converged_prop;
	xproj_fit_converged_prop.set_label("X Projection Fit Converged");
	xproj_fit_converged_prop.set_description("true of the projection fitting algorithm has converged");
	xproj_fit_converged->set_default_properties(xproj_fit_converged_prop);
	att_list.push_back(xproj_fit_converged);

	//	Attribute : XProjFitCenter
	XProjFitCenterAttrib	*xproj_fit_center = new XProjFitCenterAttrib();
	Tango::UserDefaultAttrProp	xproj_fit_center_prop;
	xproj_fit_center_prop.set_label("X Projection Fit Center");
	xproj_fit_center_prop.set_unit("um");
	xproj_fit_center_prop.set_format("%10.2f");
	xproj_fit_center_prop.set_description("the X position of the center of the fitted gaussian corresponding to the X projection");
	xproj_fit_center->set_default_properties(xproj_fit_center_prop);
	att_list.push_back(xproj_fit_center);

	//	Attribute : XProjFitMag
	XProjFitMagAttrib	*xproj_fit_mag = new XProjFitMagAttrib();
	Tango::UserDefaultAttrProp	xproj_fit_mag_prop;
	xproj_fit_mag_prop.set_label("X Projection Fit Magnitude");
	xproj_fit_mag_prop.set_unit(" ");
	xproj_fit_mag_prop.set_format("%10.2f");
	xproj_fit_mag_prop.set_description("the magnitude of  fitted gaussian corresponding to the X projection");
	xproj_fit_mag->set_default_properties(xproj_fit_mag_prop);
	att_list.push_back(xproj_fit_mag);

	//	Attribute : XProjFitSigma
	XProjFitSigmaAttrib	*xproj_fit_sigma = new XProjFitSigmaAttrib();
	Tango::UserDefaultAttrProp	xproj_fit_sigma_prop;
	xproj_fit_sigma_prop.set_label("X Projection Fit Sigma");
	xproj_fit_sigma_prop.set_unit("um");
	xproj_fit_sigma_prop.set_format("%10.2f");
	xproj_fit_sigma_prop.set_description("the standard deviation of  fitted gaussian corresponding to the X projection");
	xproj_fit_sigma->set_default_properties(xproj_fit_sigma_prop);
	att_list.push_back(xproj_fit_sigma);

	//	Attribute : XProjFitFWHM
	XProjFitFWHMAttrib	*xproj_fit_fwhm = new XProjFitFWHMAttrib();
	Tango::UserDefaultAttrProp	xproj_fit_fwhm_prop;
	xproj_fit_fwhm_prop.set_label("X Projection Fit FWHM");
	xproj_fit_fwhm_prop.set_unit("um");
	xproj_fit_fwhm_prop.set_format("%10.2f");
	xproj_fit_fwhm_prop.set_description("the full width at half maximum of the fitted gaussian corresponding to the X projection, calculated as approximately 2.35 * XProjFitSigma");
	xproj_fit_fwhm->set_default_properties(xproj_fit_fwhm_prop);
	att_list.push_back(xproj_fit_fwhm);

	//	Attribute : XProjFitBG
	XProjFitBGAttrib	*xproj_fit_bg = new XProjFitBGAttrib();
	Tango::UserDefaultAttrProp	xproj_fit_bg_prop;
	xproj_fit_bg_prop.set_label("X Projection Fit Background");
	xproj_fit_bg_prop.set_unit(" ");
	xproj_fit_bg_prop.set_format("%10.2f");
	xproj_fit_bg_prop.set_description("the background of  fitted gaussian corresponding to the X projection");
	xproj_fit_bg->set_default_properties(xproj_fit_bg_prop);
	att_list.push_back(xproj_fit_bg);

	//	Attribute : XProjFitChi2
	XProjFitChi2Attrib	*xproj_fit_chi2 = new XProjFitChi2Attrib();
	Tango::UserDefaultAttrProp	xproj_fit_chi2_prop;
	xproj_fit_chi2_prop.set_label("X Projection Fit Chi2");
	xproj_fit_chi2_prop.set_unit(" ");
	xproj_fit_chi2_prop.set_format("%10.2f");
	xproj_fit_chi2_prop.set_description("the chi-2 of  fitted gaussian corresponding to the X projection");
	xproj_fit_chi2->set_default_properties(xproj_fit_chi2_prop);
	att_list.push_back(xproj_fit_chi2);

	//	Attribute : YProjFitConverged
	YProjFitConvergedAttrib	*yproj_fit_converged = new YProjFitConvergedAttrib();
	Tango::UserDefaultAttrProp	yproj_fit_converged_prop;
	yproj_fit_converged_prop.set_label("Y Projection Fit Converged");
	yproj_fit_converged_prop.set_description("true of the projection fitting algorithm has converged");
	yproj_fit_converged->set_default_properties(yproj_fit_converged_prop);
	att_list.push_back(yproj_fit_converged);

	//	Attribute : YProjFitCenter
	YProjFitCenterAttrib	*yproj_fit_center = new YProjFitCenterAttrib();
	Tango::UserDefaultAttrProp	yproj_fit_center_prop;
	yproj_fit_center_prop.set_label("Y Projection Fit Center");
	yproj_fit_center_prop.set_unit("um");
	yproj_fit_center_prop.set_format("%10.2f");
	yproj_fit_center_prop.set_description("the Y position of the center of the fitted gaussian corresponding to the Y projection");
	yproj_fit_center->set_default_properties(yproj_fit_center_prop);
	att_list.push_back(yproj_fit_center);

	//	Attribute : YProjFitMag
	YProjFitMagAttrib	*yproj_fit_mag = new YProjFitMagAttrib();
	Tango::UserDefaultAttrProp	yproj_fit_mag_prop;
	yproj_fit_mag_prop.set_label("Y Projection Fit Magnitude");
	yproj_fit_mag_prop.set_unit(" ");
	yproj_fit_mag_prop.set_format("%10.2f");
	yproj_fit_mag_prop.set_description("the magnitude of  fitted gaussian corresponding to the Y projection");
	yproj_fit_mag->set_default_properties(yproj_fit_mag_prop);
	att_list.push_back(yproj_fit_mag);

	//	Attribute : YProjFitSigma
	YProjFitSigmaAttrib	*yproj_fit_sigma = new YProjFitSigmaAttrib();
	Tango::UserDefaultAttrProp	yproj_fit_sigma_prop;
	yproj_fit_sigma_prop.set_label("Y Projection Fit Sigma");
	yproj_fit_sigma_prop.set_unit("um");
	yproj_fit_sigma_prop.set_format("%10.2f");
	yproj_fit_sigma_prop.set_description("the standard deviation of  fitted gaussian corresponding to the Y projection");
	yproj_fit_sigma->set_default_properties(yproj_fit_sigma_prop);
	att_list.push_back(yproj_fit_sigma);

	//	Attribute : YProjFitFWHM
	YProjFitFWHMAttrib	*yproj_fit_fwhm = new YProjFitFWHMAttrib();
	Tango::UserDefaultAttrProp	yproj_fit_fwhm_prop;
	yproj_fit_fwhm_prop.set_label("Y Projection Fit FWHM");
	yproj_fit_fwhm_prop.set_unit("um");
	yproj_fit_fwhm_prop.set_format("%10.2f");
	yproj_fit_fwhm_prop.set_description("the full width at half maximum of the fitted gaussian corresponding to the Y projection, calculated approximately as 2.35 * YProjFitSigma");
	yproj_fit_fwhm->set_default_properties(yproj_fit_fwhm_prop);
	att_list.push_back(yproj_fit_fwhm);

	//	Attribute : YProjFitBG
	YProjFitBGAttrib	*yproj_fit_bg = new YProjFitBGAttrib();
	Tango::UserDefaultAttrProp	yproj_fit_bg_prop;
	yproj_fit_bg_prop.set_label("Y Projection Fit Background");
	yproj_fit_bg_prop.set_unit(" ");
	yproj_fit_bg_prop.set_format("%10.2f");
	yproj_fit_bg_prop.set_description("the background of  fitted gaussian corresponding to the Y projection");
	yproj_fit_bg->set_default_properties(yproj_fit_bg_prop);
	att_list.push_back(yproj_fit_bg);

	//	Attribute : YProjFitChi2
	YProjFitChi2Attrib	*yproj_fit_chi2 = new YProjFitChi2Attrib();
	Tango::UserDefaultAttrProp	yproj_fit_chi2_prop;
	yproj_fit_chi2_prop.set_label("Y Projection Fit Chi2");
	yproj_fit_chi2_prop.set_unit(" ");
	yproj_fit_chi2_prop.set_format("%10.2f");
	yproj_fit_chi2_prop.set_description("the chi-2 of  fitted gaussian corresponding to the Y projection");
	yproj_fit_chi2->set_default_properties(yproj_fit_chi2_prop);
	att_list.push_back(yproj_fit_chi2);

	//	Attribute : LineProfileFitConverged
	LineProfileFitConvergedAttrib	*line_profile_fit_converged = new LineProfileFitConvergedAttrib();
	Tango::UserDefaultAttrProp	line_profile_fit_converged_prop;
	line_profile_fit_converged_prop.set_label("LineProfile Fit Converged");
	line_profile_fit_converged_prop.set_description("true of the profile fitting algorithm has converged");
	line_profile_fit_converged->set_default_properties(line_profile_fit_converged_prop);
	att_list.push_back(line_profile_fit_converged);

	//	Attribute : LineProfileFitCenter
	LineProfileFitCenterAttrib	*line_profile_fit_center = new LineProfileFitCenterAttrib();
	Tango::UserDefaultAttrProp	line_profile_fit_center_prop;
	line_profile_fit_center_prop.set_label("LineProfile Fit Center");
	line_profile_fit_center_prop.set_unit("pix");
	line_profile_fit_center_prop.set_format("%10.2f");
	line_profile_fit_center_prop.set_description("the Y position of the center of the fitted gaussian corresponding to the line profile");
	line_profile_fit_center->set_default_properties(line_profile_fit_center_prop);
	att_list.push_back(line_profile_fit_center);

	//	Attribute : LineProfileFitMag
	LineProfileFitMagAttrib	*line_profile_fit_mag = new LineProfileFitMagAttrib();
	Tango::UserDefaultAttrProp	line_profile_fit_mag_prop;
	line_profile_fit_mag_prop.set_label("LineProfile Fit Magnitude");
	line_profile_fit_mag_prop.set_unit(" ");
	line_profile_fit_mag_prop.set_format("%10.2f");
	line_profile_fit_mag_prop.set_description("the magnitude of  fitted gaussian corresponding to the line profile");
	line_profile_fit_mag->set_default_properties(line_profile_fit_mag_prop);
	att_list.push_back(line_profile_fit_mag);

	//	Attribute : LineProfileFitSigma
	LineProfileFitSigmaAttrib	*line_profile_fit_sigma = new LineProfileFitSigmaAttrib();
	Tango::UserDefaultAttrProp	line_profile_fit_sigma_prop;
	line_profile_fit_sigma_prop.set_label("LineProfile Fit Sigma");
	line_profile_fit_sigma_prop.set_unit("pix");
	line_profile_fit_sigma_prop.set_format("%10.2f");
	line_profile_fit_sigma_prop.set_description("the standard deviation of  fitted gaussian corresponding to the line profile");
	line_profile_fit_sigma->set_default_properties(line_profile_fit_sigma_prop);
	att_list.push_back(line_profile_fit_sigma);

	//	Attribute : LineProfileFitFWHM
	LineProfileFitFWHMAttrib	*line_profile_fit_fwhm = new LineProfileFitFWHMAttrib();
	Tango::UserDefaultAttrProp	line_profile_fit_fwhm_prop;
	line_profile_fit_fwhm_prop.set_label("LineProfile Fit FWHM");
	line_profile_fit_fwhm_prop.set_unit("pix");
	line_profile_fit_fwhm_prop.set_format("%10.2f");
	line_profile_fit_fwhm_prop.set_description("the full width at half maximum of the fitted gaussian corresponding to the line profile, calculated approximately as 2.35 * LineProfileFitSigma");
	line_profile_fit_fwhm->set_default_properties(line_profile_fit_fwhm_prop);
	att_list.push_back(line_profile_fit_fwhm);

	//	Attribute : LineProfileFitBG
	LineProfileFitBGAttrib	*line_profile_fit_bg = new LineProfileFitBGAttrib();
	Tango::UserDefaultAttrProp	line_profile_fit_bg_prop;
	line_profile_fit_bg_prop.set_label("LineProfile Fit Background");
	line_profile_fit_bg_prop.set_unit(" ");
	line_profile_fit_bg_prop.set_format("%10.2f");
	line_profile_fit_bg_prop.set_description("the background of  fitted gaussian corresponding to the line profile");
	line_profile_fit_bg->set_default_properties(line_profile_fit_bg_prop);
	att_list.push_back(line_profile_fit_bg);

	//	Attribute : LineProfileFitChi2
	LineProfileFitChi2Attrib	*line_profile_fit_chi2 = new LineProfileFitChi2Attrib();
	Tango::UserDefaultAttrProp	line_profile_fit_chi2_prop;
	line_profile_fit_chi2_prop.set_label("LineProfile Fit Chi2");
	line_profile_fit_chi2_prop.set_unit(" ");
	line_profile_fit_chi2_prop.set_format("%10.2f");
	line_profile_fit_chi2_prop.set_description("the chi-2 of  fitted gaussian corresponding to the line profile");
	line_profile_fit_chi2->set_default_properties(line_profile_fit_chi2_prop);
	att_list.push_back(line_profile_fit_chi2);

	//	Attribute : GaussianFitConverged
	GaussianFitConvergedAttrib	*gaussian_fit_converged = new GaussianFitConvergedAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_converged_prop;
	gaussian_fit_converged_prop.set_label("GaussianFitConverged");
	gaussian_fit_converged_prop.set_description("true of the 2D gaussian fitting algorithm has converged");
	gaussian_fit_converged->set_default_properties(gaussian_fit_converged_prop);
	att_list.push_back(gaussian_fit_converged);

	//	Attribute : GaussianFitMagnitude
	GaussianFitMagnitudeAttrib	*gaussian_fit_magnitude = new GaussianFitMagnitudeAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_magnitude_prop;
	gaussian_fit_magnitude_prop.set_label("GaussianFitMagnitude");
	gaussian_fit_magnitude_prop.set_unit(" ");
	gaussian_fit_magnitude_prop.set_format("%10.2f");
	gaussian_fit_magnitude_prop.set_description("the magnitude of the fitted gaussian");
	gaussian_fit_magnitude->set_default_properties(gaussian_fit_magnitude_prop);
	att_list.push_back(gaussian_fit_magnitude);

	//	Attribute : GaussianFitCenterX
	GaussianFitCenterXAttrib	*gaussian_fit_center_x = new GaussianFitCenterXAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_center_x_prop;
	gaussian_fit_center_x_prop.set_label("GaussianFitCenterX");
	gaussian_fit_center_x_prop.set_unit("um");
	gaussian_fit_center_x_prop.set_format("%10.2f");
	gaussian_fit_center_x_prop.set_description("the X coordinate of the centroid of the 2D gaussian fitted to the image");
	gaussian_fit_center_x->set_default_properties(gaussian_fit_center_x_prop);
	att_list.push_back(gaussian_fit_center_x);

	//	Attribute : GaussianFitCenterY
	GaussianFitCenterYAttrib	*gaussian_fit_center_y = new GaussianFitCenterYAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_center_y_prop;
	gaussian_fit_center_y_prop.set_label("GaussianFitCenterY");
	gaussian_fit_center_y_prop.set_unit("um");
	gaussian_fit_center_y_prop.set_format("%10.2f");
	gaussian_fit_center_y_prop.set_description("the Y coordinate of the centroid of the 2D gaussian fitted to the image");
	gaussian_fit_center_y->set_default_properties(gaussian_fit_center_y_prop);
	att_list.push_back(gaussian_fit_center_y);

	//	Attribute : GaussianFitVarianceX
	GaussianFitVarianceXAttrib	*gaussian_fit_variance_x = new GaussianFitVarianceXAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_variance_x_prop;
	gaussian_fit_variance_x_prop.set_label("GaussianFitVarianceX");
	gaussian_fit_variance_x_prop.set_unit("um^2");
	gaussian_fit_variance_x_prop.set_format("%10.2f");
	gaussian_fit_variance_x_prop.set_description("the variance of the 2D gaussian along the X axis");
	gaussian_fit_variance_x->set_default_properties(gaussian_fit_variance_x_prop);
	att_list.push_back(gaussian_fit_variance_x);

	//	Attribute : GaussianFitVarianceY
	GaussianFitVarianceYAttrib	*gaussian_fit_variance_y = new GaussianFitVarianceYAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_variance_y_prop;
	gaussian_fit_variance_y_prop.set_label("GaussianFitVarianceY");
	gaussian_fit_variance_y_prop.set_unit("um^2");
	gaussian_fit_variance_y_prop.set_format("%10.2f");
	gaussian_fit_variance_y_prop.set_description("the variance of the 2D gaussian along the Y axis");
	gaussian_fit_variance_y->set_default_properties(gaussian_fit_variance_y_prop);
	att_list.push_back(gaussian_fit_variance_y);

	//	Attribute : GaussianFitCovarianceXY
	GaussianFitCovarianceXYAttrib	*gaussian_fit_covariance_xy = new GaussianFitCovarianceXYAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_covariance_xy_prop;
	gaussian_fit_covariance_xy_prop.set_label("GaussianFitCovarianceXY");
	gaussian_fit_covariance_xy_prop.set_unit("um^2");
	gaussian_fit_covariance_xy_prop.set_format("%10.2f");
	gaussian_fit_covariance_xy_prop.set_description("the covariance of the 2D gaussian");
	gaussian_fit_covariance_xy->set_default_properties(gaussian_fit_covariance_xy_prop);
	att_list.push_back(gaussian_fit_covariance_xy);

	//	Attribute : GaussianFitMajorAxisFWHM
	GaussianFitMajorAxisFWHMAttrib	*gaussian_fit_major_axis_fwhm = new GaussianFitMajorAxisFWHMAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_major_axis_fwhm_prop;
	gaussian_fit_major_axis_fwhm_prop.set_label("GaussianFitMajorAxisFWHM");
	gaussian_fit_major_axis_fwhm_prop.set_unit("um");
	gaussian_fit_major_axis_fwhm_prop.set_format("%10.2f");
	gaussian_fit_major_axis_fwhm_prop.set_description("the FWHM along the major axis of the fitted gaussian, calculated approximately as 2.35 * sqrt(GaussianFitVarianceX)");
	gaussian_fit_major_axis_fwhm->set_default_properties(gaussian_fit_major_axis_fwhm_prop);
	att_list.push_back(gaussian_fit_major_axis_fwhm);

	//	Attribute : GaussianFitMinorAxisFWHM
	GaussianFitMinorAxisFWHMAttrib	*gaussian_fit_minor_axis_fwhm = new GaussianFitMinorAxisFWHMAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_minor_axis_fwhm_prop;
	gaussian_fit_minor_axis_fwhm_prop.set_label("GaussianFitMinorAxisFWHM");
	gaussian_fit_minor_axis_fwhm_prop.set_unit("um");
	gaussian_fit_minor_axis_fwhm_prop.set_format("%10.2f");
	gaussian_fit_minor_axis_fwhm_prop.set_description("the FWHM along the minor axis of the fitted gaussian, calculated approximately as 2.35 * sqrt(GaussianFitVarianceY)");
	gaussian_fit_minor_axis_fwhm->set_default_properties(gaussian_fit_minor_axis_fwhm_prop);
	att_list.push_back(gaussian_fit_minor_axis_fwhm);

	//	Attribute : GaussianFitTilt
	GaussianFitTiltAttrib	*gaussian_fit_tilt = new GaussianFitTiltAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_tilt_prop;
	gaussian_fit_tilt_prop.set_label("GaussianFitTilt");
	gaussian_fit_tilt_prop.set_unit("deg");
	gaussian_fit_tilt_prop.set_format("%10.2f");
	gaussian_fit_tilt_prop.set_description("the angle made by the major axis of the gaussian and the X axis");
	gaussian_fit_tilt->set_default_properties(gaussian_fit_tilt_prop);
	att_list.push_back(gaussian_fit_tilt);

	//	Attribute : GaussianFitBG
	GaussianFitBGAttrib	*gaussian_fit_bg = new GaussianFitBGAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_bg_prop;
	gaussian_fit_bg_prop.set_label("GaussianFitBG");
	gaussian_fit_bg_prop.set_unit(" ");
	gaussian_fit_bg_prop.set_format("%10.2f");
	gaussian_fit_bg_prop.set_description("the background of the fitted gaussian");
	gaussian_fit_bg->set_default_properties(gaussian_fit_bg_prop);
	att_list.push_back(gaussian_fit_bg);

	//	Attribute : GaussianFitChi2
	GaussianFitChi2Attrib	*gaussian_fit_chi2 = new GaussianFitChi2Attrib();
	Tango::UserDefaultAttrProp	gaussian_fit_chi2_prop;
	gaussian_fit_chi2_prop.set_label("GaussianFitChi2");
	gaussian_fit_chi2_prop.set_unit(" ");
	gaussian_fit_chi2_prop.set_format("%10.2f");
	gaussian_fit_chi2_prop.set_description("the chi-2 of the fitted gaussian");
	gaussian_fit_chi2->set_default_properties(gaussian_fit_chi2_prop);
	att_list.push_back(gaussian_fit_chi2);

	//	Attribute : Fit1DNbIterMax
	Fit1DNbIterMaxAttrib	*fit1_dnb_iter_max = new Fit1DNbIterMaxAttrib();
	Tango::UserDefaultAttrProp	fit1_dnb_iter_max_prop;
	fit1_dnb_iter_max_prop.set_label("Fit1DNbIterMax");
	fit1_dnb_iter_max_prop.set_unit(" ");
	fit1_dnb_iter_max_prop.set_format("%5d");
	fit1_dnb_iter_max_prop.set_description("the maximal number of iteration to converge to a solution");
	fit1_dnb_iter_max->set_default_properties(fit1_dnb_iter_max_prop);
	fit1_dnb_iter_max->set_disp_level(Tango::EXPERT);
	att_list.push_back(fit1_dnb_iter_max);

	//	Attribute : Fit1DMaxRelChange
	Fit1DMaxRelChangeAttrib	*fit1_dmax_rel_change = new Fit1DMaxRelChangeAttrib();
	Tango::UserDefaultAttrProp	fit1_dmax_rel_change_prop;
	fit1_dmax_rel_change_prop.set_label("Fit1DMaxRelChange");
	fit1_dmax_rel_change_prop.set_unit(" ");
	fit1_dmax_rel_change_prop.set_format("%8.7f");
	fit1_dmax_rel_change_prop.set_description("optimization stops when the relative change between 2 iterations falls below this threshold");
	fit1_dmax_rel_change->set_default_properties(fit1_dmax_rel_change_prop);
	fit1_dmax_rel_change->set_disp_level(Tango::EXPERT);
	att_list.push_back(fit1_dmax_rel_change);

	//	Attribute : Fit2DNbIterMax
	Fit2DNbIterMaxAttrib	*fit2_dnb_iter_max = new Fit2DNbIterMaxAttrib();
	Tango::UserDefaultAttrProp	fit2_dnb_iter_max_prop;
	fit2_dnb_iter_max_prop.set_label("Fit2DNbIterMax");
	fit2_dnb_iter_max_prop.set_unit(" ");
	fit2_dnb_iter_max_prop.set_format("%5d");
	fit2_dnb_iter_max_prop.set_description("the maximal number of iteration to converge to a solution");
	fit2_dnb_iter_max->set_default_properties(fit2_dnb_iter_max_prop);
	fit2_dnb_iter_max->set_disp_level(Tango::EXPERT);
	att_list.push_back(fit2_dnb_iter_max);

	//	Attribute : Fit2DMaxRelChange
	Fit2DMaxRelChangeAttrib	*fit2_dmax_rel_change = new Fit2DMaxRelChangeAttrib();
	Tango::UserDefaultAttrProp	fit2_dmax_rel_change_prop;
	fit2_dmax_rel_change_prop.set_label("Fit2DMaxRelChange");
	fit2_dmax_rel_change_prop.set_unit(" ");
	fit2_dmax_rel_change_prop.set_format("%8.7f");
	fit2_dmax_rel_change_prop.set_description("optimization stops when the relative change between 2 iterations falls below this threshold");
	fit2_dmax_rel_change->set_default_properties(fit2_dmax_rel_change_prop);
	fit2_dmax_rel_change->set_disp_level(Tango::EXPERT);
	att_list.push_back(fit2_dmax_rel_change);

	//	Attribute : XProjFitNbIter
	XProjFitNbIterAttrib	*xproj_fit_nb_iter = new XProjFitNbIterAttrib();
	Tango::UserDefaultAttrProp	xproj_fit_nb_iter_prop;
	xproj_fit_nb_iter_prop.set_label("XProfile Nb Iter");
	xproj_fit_nb_iter_prop.set_unit(" ");
	xproj_fit_nb_iter_prop.set_format("%10d");
	xproj_fit_nb_iter_prop.set_description("the number of iterations needed to converge to the fitted profile");
	xproj_fit_nb_iter->set_default_properties(xproj_fit_nb_iter_prop);
	xproj_fit_nb_iter->set_disp_level(Tango::EXPERT);
	att_list.push_back(xproj_fit_nb_iter);

	//	Attribute : XProjFitRelChange
	XProjFitRelChangeAttrib	*xproj_fit_rel_change = new XProjFitRelChangeAttrib();
	Tango::UserDefaultAttrProp	xproj_fit_rel_change_prop;
	xproj_fit_rel_change_prop.set_label("XProfile Fit Rel. Change");
	xproj_fit_rel_change_prop.set_unit(" ");
	xproj_fit_rel_change_prop.set_format("%10.6f");
	xproj_fit_rel_change_prop.set_description("the relative change in the fit parameters between the two last iterations");
	xproj_fit_rel_change->set_default_properties(xproj_fit_rel_change_prop);
	xproj_fit_rel_change->set_disp_level(Tango::EXPERT);
	att_list.push_back(xproj_fit_rel_change);

	//	Attribute : YProjFitNbIter
	YProjFitNbIterAttrib	*yproj_fit_nb_iter = new YProjFitNbIterAttrib();
	Tango::UserDefaultAttrProp	yproj_fit_nb_iter_prop;
	yproj_fit_nb_iter_prop.set_label("YProfile Nb Iter");
	yproj_fit_nb_iter_prop.set_unit(" ");
	yproj_fit_nb_iter_prop.set_format("%10d");
	yproj_fit_nb_iter_prop.set_description("the number of iterations needed to converge to the fitted profile");
	yproj_fit_nb_iter->set_default_properties(yproj_fit_nb_iter_prop);
	yproj_fit_nb_iter->set_disp_level(Tango::EXPERT);
	att_list.push_back(yproj_fit_nb_iter);

	//	Attribute : YProjFitRelChange
	YProjFitRelChangeAttrib	*yproj_fit_rel_change = new YProjFitRelChangeAttrib();
	Tango::UserDefaultAttrProp	yproj_fit_rel_change_prop;
	yproj_fit_rel_change_prop.set_label("YProfile Fit Rel. Change");
	yproj_fit_rel_change_prop.set_unit(" ");
	yproj_fit_rel_change_prop.set_format("%10.6f");
	yproj_fit_rel_change_prop.set_description("the relative change in the fit parameters between the two last iterations");
	yproj_fit_rel_change->set_default_properties(yproj_fit_rel_change_prop);
	yproj_fit_rel_change->set_disp_level(Tango::EXPERT);
	att_list.push_back(yproj_fit_rel_change);

	//	Attribute : LineProfileFitNbIter
	LineProfileFitNbIterAttrib	*line_profile_fit_nb_iter = new LineProfileFitNbIterAttrib();
	Tango::UserDefaultAttrProp	line_profile_fit_nb_iter_prop;
	line_profile_fit_nb_iter_prop.set_label("LineProfile Nb Iter");
	line_profile_fit_nb_iter_prop.set_unit(" ");
	line_profile_fit_nb_iter_prop.set_format("%10d");
	line_profile_fit_nb_iter_prop.set_description("the number of iterations needed to converge to the fitted profile");
	line_profile_fit_nb_iter->set_default_properties(line_profile_fit_nb_iter_prop);
	line_profile_fit_nb_iter->set_disp_level(Tango::EXPERT);
	att_list.push_back(line_profile_fit_nb_iter);

	//	Attribute : LineProfileFitRelChange
	LineProfileFitRelChangeAttrib	*line_profile_fit_rel_change = new LineProfileFitRelChangeAttrib();
	Tango::UserDefaultAttrProp	line_profile_fit_rel_change_prop;
	line_profile_fit_rel_change_prop.set_label("LineProfile Fit Rel. Change");
	line_profile_fit_rel_change_prop.set_unit(" ");
	line_profile_fit_rel_change_prop.set_format("%10.6f");
	line_profile_fit_rel_change_prop.set_description("the relative change in the fit parameters between the two last iterations");
	line_profile_fit_rel_change->set_default_properties(line_profile_fit_rel_change_prop);
	line_profile_fit_rel_change->set_disp_level(Tango::EXPERT);
	att_list.push_back(line_profile_fit_rel_change);

	//	Attribute : GaussianFitNbIter
	GaussianFitNbIterAttrib	*gaussian_fit_nb_iter = new GaussianFitNbIterAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_nb_iter_prop;
	gaussian_fit_nb_iter_prop.set_label("GaussianFit Nb Iter");
	gaussian_fit_nb_iter_prop.set_unit(" ");
	gaussian_fit_nb_iter_prop.set_format("%10d");
	gaussian_fit_nb_iter_prop.set_description("the number of iterations needed to converge to the fitted image");
	gaussian_fit_nb_iter->set_default_properties(gaussian_fit_nb_iter_prop);
	gaussian_fit_nb_iter->set_disp_level(Tango::EXPERT);
	att_list.push_back(gaussian_fit_nb_iter);

	//	Attribute : GaussianFitRelChange
	GaussianFitRelChangeAttrib	*gaussian_fit_rel_change = new GaussianFitRelChangeAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_rel_change_prop;
	gaussian_fit_rel_change_prop.set_label("GaussianFit Rel. Change");
	gaussian_fit_rel_change_prop.set_unit(" ");
	gaussian_fit_rel_change_prop.set_format("%10.6f");
	gaussian_fit_rel_change_prop.set_description("the relative change in the fit parameters between the two last iterations");
	gaussian_fit_rel_change->set_default_properties(gaussian_fit_rel_change_prop);
	gaussian_fit_rel_change->set_disp_level(Tango::EXPERT);
	att_list.push_back(gaussian_fit_rel_change);

	//	Attribute : RmsX
	RmsXAttrib	*rms_x = new RmsXAttrib();
	Tango::UserDefaultAttrProp	rms_x_prop;
	rms_x_prop.set_label("RmsX");
	rms_x_prop.set_unit("um");
	rms_x_prop.set_format("%10.3f");
	rms_x_prop.set_description("the variance square root along the X axis");
	rms_x->set_default_properties(rms_x_prop);
	att_list.push_back(rms_x);

	//	Attribute : RmsY
	RmsYAttrib	*rms_y = new RmsYAttrib();
	Tango::UserDefaultAttrProp	rms_y_prop;
	rms_y_prop.set_label("RmsY");
	rms_y_prop.set_unit("um");
	rms_y_prop.set_format("%10.3f");
	rms_y_prop.set_description("the variance square root along the Y axis");
	rms_y->set_default_properties(rms_y_prop);
	att_list.push_back(rms_y);

	//	Attribute : XProj
	XProjAttrib	*xproj = new XProjAttrib();
	Tango::UserDefaultAttrProp	xproj_prop;
	xproj_prop.set_label("XProfile");
	xproj_prop.set_unit(" ");
	xproj_prop.set_format("%10.4f");
	xproj_prop.set_description("the mean value along the X axis");
	xproj->set_default_properties(xproj_prop);
	att_list.push_back(xproj);

	//	Attribute : XProjFitted
	XProjFittedAttrib	*xproj_fitted = new XProjFittedAttrib();
	Tango::UserDefaultAttrProp	xproj_fitted_prop;
	xproj_fitted_prop.set_label("XProfileFitted");
	xproj_fitted_prop.set_unit(" ");
	xproj_fitted_prop.set_format("%10.2f");
	xproj_fitted_prop.set_description("the gaussian fit result of XProj");
	xproj_fitted->set_default_properties(xproj_fitted_prop);
	xproj_fitted->set_disp_level(Tango::EXPERT);
	att_list.push_back(xproj_fitted);

	//	Attribute : XProjError
	XProjErrorAttrib	*xproj_error = new XProjErrorAttrib();
	Tango::UserDefaultAttrProp	xproj_error_prop;
	xproj_error_prop.set_label("XProfileError");
	xproj_error_prop.set_unit(" ");
	xproj_error_prop.set_format("%10.2f");
	xproj_error_prop.set_description("the fitted profile error along the X axis");
	xproj_error->set_default_properties(xproj_error_prop);
	xproj_error->set_disp_level(Tango::EXPERT);
	att_list.push_back(xproj_error);

	//	Attribute : YProj
	YProjAttrib	*yproj = new YProjAttrib();
	Tango::UserDefaultAttrProp	yproj_prop;
	yproj_prop.set_label("YProfile");
	yproj_prop.set_unit(" ");
	yproj_prop.set_format("%10.4f");
	yproj_prop.set_description("the mean value along the Y axis");
	yproj->set_default_properties(yproj_prop);
	att_list.push_back(yproj);

	//	Attribute : YProjFitted
	YProjFittedAttrib	*yproj_fitted = new YProjFittedAttrib();
	Tango::UserDefaultAttrProp	yproj_fitted_prop;
	yproj_fitted_prop.set_label("YProfileFitted");
	yproj_fitted_prop.set_unit(" ");
	yproj_fitted_prop.set_format("%10.2f");
	yproj_fitted_prop.set_description("the gaussian fit result of XProj");
	yproj_fitted->set_default_properties(yproj_fitted_prop);
	yproj_fitted->set_disp_level(Tango::EXPERT);
	att_list.push_back(yproj_fitted);

	//	Attribute : YProjError
	YProjErrorAttrib	*yproj_error = new YProjErrorAttrib();
	Tango::UserDefaultAttrProp	yproj_error_prop;
	yproj_error_prop.set_label("YProfileError");
	yproj_error_prop.set_unit(" ");
	yproj_error_prop.set_format("%10.2f");
	yproj_error_prop.set_description("the fitted profile error along the Y axis");
	yproj_error->set_default_properties(yproj_error_prop);
	yproj_error->set_disp_level(Tango::EXPERT);
	att_list.push_back(yproj_error);

	//	Attribute : LineProfile
	LineProfileAttrib	*line_profile = new LineProfileAttrib();
	Tango::UserDefaultAttrProp	line_profile_prop;
	line_profile_prop.set_label("Line Profile");
	line_profile_prop.set_unit(" ");
	line_profile_prop.set_format("%10.2f");
	line_profile_prop.set_description("the line profile values");
	line_profile->set_default_properties(line_profile_prop);
	att_list.push_back(line_profile);

	//	Attribute : LineProfileFitted
	LineProfileFittedAttrib	*line_profile_fitted = new LineProfileFittedAttrib();
	Tango::UserDefaultAttrProp	line_profile_fitted_prop;
	line_profile_fitted_prop.set_label("LineProfileFitted");
	line_profile_fitted_prop.set_unit(" ");
	line_profile_fitted_prop.set_format("%10.2f");
	line_profile_fitted_prop.set_description("the fitted line profile");
	line_profile_fitted->set_default_properties(line_profile_fitted_prop);
	line_profile_fitted->set_disp_level(Tango::EXPERT);
	att_list.push_back(line_profile_fitted);

	//	Attribute : LineProfileError
	LineProfileErrorAttrib	*line_profile_error = new LineProfileErrorAttrib();
	Tango::UserDefaultAttrProp	line_profile_error_prop;
	line_profile_error_prop.set_label("LineProfileError");
	line_profile_error_prop.set_unit(" ");
	line_profile_error_prop.set_format("%10.2f");
	line_profile_error_prop.set_description("the fitted line profile error");
	line_profile_error->set_default_properties(line_profile_error_prop);
	line_profile_error->set_disp_level(Tango::EXPERT);
	att_list.push_back(line_profile_error);

	//	Attribute : Histogram
	HistogramAttrib	*histogram = new HistogramAttrib();
	att_list.push_back(histogram);

	//	Attribute : InputImage
	InputImageAttrib	*input_image = new InputImageAttrib();
	Tango::UserDefaultAttrProp	input_image_prop;
	input_image_prop.set_label("InputImage");
	input_image_prop.set_description("raw copy of the input image");
	input_image->set_default_properties(input_image_prop);
	att_list.push_back(input_image);

	//	Attribute : ROIImage
	ROIImageAttrib	*roiimage = new ROIImageAttrib();
	Tango::UserDefaultAttrProp	roiimage_prop;
	roiimage_prop.set_label("ROI Image");
	roiimage_prop.set_unit(" ");
	roiimage_prop.set_description("the effective image on which are done all the calculation");
	roiimage->set_default_properties(roiimage_prop);
	att_list.push_back(roiimage);

	//	Attribute : LineProfileHelperImg
	LineProfileHelperImgAttrib	*line_profile_helper_img = new LineProfileHelperImgAttrib();
	Tango::UserDefaultAttrProp	line_profile_helper_img_prop;
	line_profile_helper_img_prop.set_label("Line Profile Helper Image");
	line_profile_helper_img_prop.set_unit(" ");
	line_profile_helper_img_prop.set_description("the intermediate image used in the calculation of the Line Profile. this corresponds to the input rectangle defined by origin, end and thickness, affine transformed to fit in a rectangular image. The colums of this image are averaged to give the LineProfile attribute");
	line_profile_helper_img->set_default_properties(line_profile_helper_img_prop);
	line_profile_helper_img->set_disp_level(Tango::EXPERT);
	att_list.push_back(line_profile_helper_img);

	//	Attribute : GaussianFitParameterCovariance
	GaussianFitParameterCovarianceAttrib	*gaussian_fit_parameter_covariance = new GaussianFitParameterCovarianceAttrib();
	Tango::UserDefaultAttrProp	gaussian_fit_parameter_covariance_prop;
	gaussian_fit_parameter_covariance_prop.set_label("GaussianFitParameterCovariance");
	gaussian_fit_parameter_covariance_prop.set_unit(" ");
	gaussian_fit_parameter_covariance_prop.set_format("%10.2f");
	gaussian_fit_parameter_covariance_prop.set_description("the covariance matrix of the best fit parameters (7x7). the 7 parameters are ordered as [A, xc, yc, s_xx, s_xy, s_yy, b]");
	gaussian_fit_parameter_covariance->set_default_properties(gaussian_fit_parameter_covariance_prop);
	gaussian_fit_parameter_covariance->set_disp_level(Tango::EXPERT);
	att_list.push_back(gaussian_fit_parameter_covariance);

	ImageCounterAttrib *image_counter = new ImageCounterAttrib();
	Tango::UserDefaultAttrProp image_counter_prop;
	image_counter_prop.set_format("%10d");
	image_counter->set_default_properties(image_counter_prop);
	image_counter->set_change_event(true, false);
	att_list.push_back(image_counter);
	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void ImgBeamAnalyzerClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	ImgBeamAnalyzerClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void ImgBeamAnalyzerClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "AutoROIMagFactorX";
	prop_desc = "initial value of AutoROIMagFactorX attribute. if not defined, it is set to 1";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AutoROIMagFactorY";
	prop_desc = "initial value of AutoROIMagFactorY attribute. if not defined, it is set to 1";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AutoROIMethod";
	prop_desc = "the method used for computing the AutoROI. can be 'PROFILES' or 'THRESHOLD'.\nPROFILES method means the AutoROI is computed from the profiles fitted to gaussian functions.\nTHRESHOLD means that the image is first thresholded using the 'AutoROIThreshold' attribute then the largest blob is selected.\n";
	prop_def  = "PROFILES";
	vect_data.clear();
	vect_data.push_back("PROFILES");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AutoStart";
	prop_desc = "if set to 'true' and mode is 'CONTINUOUS', the computation starts automatically when the device is launched";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "BitsPerPixel";
	prop_desc = "the initial value of the BitsPerPixel attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ComputationPeriod";
	prop_desc = "the initial value of the ComputationPeriod attribute";
	prop_def  = "1000";
	vect_data.clear();
	vect_data.push_back("1000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Enable2DGaussianFit";
	prop_desc = "the initial value of the Enable2DGaussianFit attribute";
	prop_def  = "false";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "EnableAutoROI";
	prop_desc = "the initial value of the EnableAutoROI attribute";
	prop_def  = "false";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "EnableHistogram";
	prop_desc = "the initial value of the EnableHistogram attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "EnableImageStats";
	prop_desc = "the initial value of the EnableImageStats attribute";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "EnableProfiles";
	prop_desc = "the initial value of the EnableProfiles attribute";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "EnableUserROI";
	prop_desc = "the initial value of the EnableUserROI attribute";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "GammaCorrection";
	prop_desc = "the initial value of the GammaCorrection attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "HistogramNbBins";
	prop_desc = "the initial value of the HistogramNbBins attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "HistogramRangeMax";
	prop_desc = "the upper bound of the histogram bins. must be <= 2^BitsPerPixel";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "HistogramRangeMin";
	prop_desc = "the lower bound of the histogram bins. must be >= 0";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "HorizontalFlip";
	prop_desc = "the initial value of the HorizontalFlip attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ImageAttributeName";
	prop_desc = "the name of the image attribute to take in ImageDevice";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ImageCounterAttrName";
	prop_desc = "the name of the imageCounter attribute to take in ImageDevice";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ImageDevice";
	prop_desc = "the device from which the image is taken";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Mode";
	prop_desc = "ONESHOT or CONTINUOUS or EVENT";
	prop_def  = "ONESHOT";
	vect_data.clear();
	vect_data.push_back("ONESHOT");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "OpticalMagnification";
	prop_desc = "the initial value of the OpticalMagnification attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PixelSizeX";
	prop_desc = "the initial value of the PixelSizeX attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PixelSizeY";
	prop_desc = "the initial value of the PixelSizeY attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ProfileFitFixedBg";
	prop_desc = "the initial value of the ProfileFitFixedBg attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Rotation";
	prop_desc = "the initial value of the Rotation attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "UserROIOriginX";
	prop_desc = "The memorized value of userROIOriginX attribute when SaveCurrentSettings command is called.<br>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "UserROIOriginY";
	prop_desc = "The memorized value of userROIOriginY attribute when SaveCurrentSettings command is called.<br>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "UserROIWidth";
	prop_desc = "The memorized value of userROIWidth attribute when SaveCurrentSettings command is called.<br>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "UserROIHeight";
	prop_desc = "The memorized value of userROIHeight attribute when SaveCurrentSettings command is called.<br>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ChamberOffsetX";
	prop_desc = "the initial value of the ChamberOffsetX attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ChamberOffsetY";
	prop_desc = "the initial value of the ChamberOffsetY attribute";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CentroidSaturationRegionSide";
	prop_desc = "the initial value of the CentroidSaturationRegionSide attribute";
	prop_def  = "5";
	if (prop_def.length()>0)
	{
		Tango::DbDatum  data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CentroidSaturationRegionThreshold";
	prop_desc = "the initial value of the CentroidSaturationRegionThreshold attribute";
	prop_def  = "5";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CleanCurrentDataOnError";
	prop_desc = "If true then current data will be deleted when IBA's state turn to FAULT";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		ImgBeamAnalyzerClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void ImgBeamAnalyzerClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Image Analyzer");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("The device analyzes images accessible on another remote device,");
	str_desc.push_back("and proposes the following (selectable) features :");
	str_desc.push_back("- in preprocessing : rotation, mirroring, gamma correction");
	str_desc.push_back("- ROI (Region Of Interest), either user-defined or automatic by blob analysis");
	str_desc.push_back("- image moments (mean intensity, centroid, variance, skew)");
	str_desc.push_back("- maximal intensity (to monitor saturation for example)");
	str_desc.push_back("- ellipse fitting when automatic ROI is desired");
	str_desc.push_back("- profiles with corresponding gaussian fit");
	str_desc.push_back("- 2D gaussian fit of the image");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs or svn location
	string	filename(classname);
	filename += "Class.cpp";
	
	// Create a string with the class ID to
	// get the string into the binary
	string	class_id(ClassId);
	
	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}
	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
